## rgerganov-footswitch.zip

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(footswitch C)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY build)
set(SRCDIR src)

find_package(PkgConfig)
pkg_check_modules(HIDAPI REQUIRED hidapi-libusb)

include_directories(${HIDAPI_INCLUDE_DIRS} include)
link_libraries(${HIDAPI_LIBRARIES})
link_directories(src)

foreach(exe IN ITEMS footswitch scythe scythe2)
  add_executable(${exe}
    ${SRCDIR}/common.c
    ${SRCDIR}/debug.c
    ${SRCDIR}/${exe}.c
  )

  install(TARGETS ${exe}
    RUNTIME DESTINATION bin
  )
endforeach()

=== Makefile ===
PREFIX		:= /usr/local
UDEVPREFIX	:= /etc/udev

TARGETS	:= \
	footswitch \
	scythe \
	scythe2

INCDIR		:= include
SRCDIR		:= src
OBJDIR		:= obj

COMMONSRC	:= \
	common.c \
	debug.c

INSTALL	:= /usr/bin/install -c
INSTALLDATA	:= /usr/bin/install -c -m 644
CFLAGS		:= -Wall -I$(INCDIR)
UNAME		:= $(shell uname)

ifeq ($(UNAME), Darwin)
	CFLAGS	+= -DOSX $(shell pkg-config --cflags hidapi)
	LDLIBS	:= $(shell pkg-config --libs hidapi)
else
	ifeq ($(UNAME), Linux)
		CFLAGS	+= $(shell pkg-config --cflags hidapi-libusb)
		LDLIBS	:= $(shell pkg-config --libs hidapi-libusb)
	else
		LDLIBS	:= -lhidapi
	endif
endif

all: $(OBJDIR) $(TARGETS)

$(OBJDIR):
	mkdir $@

$(OBJDIR)/%.o: $(SRCDIR)/%.c
	$(CC) $(CFLAGS) -c -o $@ $<

$(TARGETS): %: $(patsubst %.c, $(OBJDIR)/%.o, $(COMMONSRC)) $(OBJDIR)/%.o
	$(CC) $(CFLAGS) -o $@ $^ $(LDLIBS)

install: all
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/bin
	for target in $(TARGETS); do \
		$(INSTALL) "$$target" $(DESTDIR)$(PREFIX)/bin; \
	done
ifeq ($(UNAME), Linux)
	$(INSTALL) -d $(DESTDIR)$(UDEVPREFIX)/rules.d
	$(INSTALLDATA) 19-footswitch.rules $(DESTDIR)$(UDEVPREFIX)/rules.d
endif

uninstall:
	rm -f $(addprefix $(DESTDIR)$(PREFIX)/bin/, $(TARGETS))
ifeq ($(UNAME), Linux)
	rm -f $(DESTDIR)$(UDEVPREFIX)/rules.d/19-footswitch.rules
endif

clean:
	rm -rf $(TARGETS) $(OBJDIR)

=== debian/changelog ===
footswitch (1.0.0) stable; urgency=medium

  * Initial release.

 -- drlkf <drlkf@drlkf.net>  Thu, 16 May 2024 19:27:47 +0200

=== debian/control ===
Source: footswitch
Section: utils
Priority: optional
Maintainer: Radoslav Gerganov <rgerganov@gmail.com>
Build-Depends:
  cmake,
  libhidapi-dev,
  pkg-config

Package: footswitch
Description: Command-line tools to configure PCsensor and Scythe foot switches.
Architecture: any
Depends:
  libhidapi-libusb0
